<template>
  <JText
    v-if="message.type === MessageTypes.EndCall"
    type="text-2"
    :weight="weightText"
    color="secondary-title"
    class="call-message"
  >
    <SystemMessage v-if="isCanceledCall"> {{ $t('cancelled_call_info') }} </SystemMessage>
    <SystemMessage v-else>
      {{ $t('call_is_end') }}
      <span class="call-duration">
        {{ callDuration }}
      </span>
    </SystemMessage>
  </JText>
  <JText
    v-if="message.type === MessageTypes.CallOffer"
    type="text-2"
    :weight="weightText"
    color="secondary-title"
    class="call-message"
  >
    <template v-if="isOutgoingCall">
      <JIcon icon="phone" />
      <SystemMessage class="outgoing-call"> {{ $t('outgoing_call') }} </SystemMessage>
    </template>
    <template v-else>
      <JIcon icon="phone" />
      <SystemMessage class="incoming-call"> {{ $t('ingoing_call') }} </SystemMessage>
    </template>
  </JText>
</template>

<script setup lang="ts">
import { PropType, computed } from 'vue';
import { storeToRefs } from 'pinia';
import { useUserStore } from '@new-jira-clone/libs/src/store';
import { JText, JIcon } from '@new-jira-clone/ui/src/components';
import { useGetCallDuration } from '@/entities/Message';
import { IMessage, MessageTypes } from '@/shared';
import { SystemMessage } from '@/shared/ui';

const props = defineProps({
  message: {
    type: Object as PropType<IMessage>,
    required: true,
  },
  weightText: {
    type: String,
    required: true,
  },
});

const { callDuration } = useGetCallDuration(props.message);

const { getUser } = storeToRefs(useUserStore());

const isOutgoingCall = computed(() => props.message.author.id === getUser.value?.id);

const isCanceledCall = computed(() => !props.message.extra);
</script>

<style lang="scss" scoped>
.call-message {
  display: flex;
  align-items: center;
}

.call-duration {
  font-weight: 600;
}

.outgoing-call,
.incoming-call {
  margin-left: 2px;
}
</style>
